$debug

function mail_buildheader( tab )
   local addheader
   
   addheader = format( "X-Sender: %s\n", "CGILua Mail" )
   addheader = addheader .. format( "Mime-Version: 1.0\n" )
   addheader = addheader .. format(	"Content-Type: text/plain; charset=\"iso-8859-1\"\n" )

   local remotehost = getenv( "REMOTE_HOST" )
   local remoteuser = getenv( "REMOTE_USER" )
   local useragent = getenv( "HTTP_USER_AGENT" )

   if remotehost then
     if not remoteuser then remoteuser = "anonymous" end
     addheader = addheader .. format( "X-RemoteUser: %s\n", remoteuser .. '@' .. remotehost )
   end

   if useragent then
     addheader = addheader .. format( "X-UserAgent: %s\n", useragent )
   end

   local f, elem = next(tab, nil)
   while f do
   if type(f)=='string' and type(elem)=='string' then
     addheader = addheader .. format( "%s: %s\n", f, elem )
     end
     f, elem = next(tab, f)
   end

   addheader = addheader .. "\n"

   return addheader
end


function mail(tab)
   if type(tab)~='table' or
      not tab.to or type(tab.to)~='string' then
      return writeto()
   end
   if %writeto("|/usr/lib/sendmail -t -oi") then
      local msg = tab.message
      tab.message = nil
      write( mail_buildheader(tab) )
      write( msg )
      writeto()
      return 1
   end
   return nil
end


