#include "lstate.h"

/*
** $Id: luadebug.h,v 1.6 1999/03/04 21:17:26 roberto Exp $
** Debugging API
** See Copyright Notice in lua.h
*/


#ifndef luadebug_h
#define luadebug_h


#include "lua.h"

typedef lua_Object lua_Function;

typedef void (*lua_LHFunction) (lua_State *L, int line);
typedef void (*lua_CHFunction) (lua_State *L, lua_Function func, char *file, int line);

lua_Function lua_stackedfunction (lua_State *L, int level);
void lua_funcinfo (lua_State *L, lua_Object func, char **source, int *linedefined);
int lua_currentline (lua_State *L, lua_Function func);
char *lua_getobjname (lua_State *L, lua_Object o, char **name);

lua_Object lua_getlocal (lua_State *L, lua_Function func, int local_number, char **name);
int lua_setlocal (lua_State *L, lua_Function func, int local_number);

int lua_nups (lua_State *L, lua_Function func);

lua_LHFunction lua_setlinehook (lua_State *L, lua_LHFunction func);
lua_CHFunction lua_setcallhook (lua_State *L, lua_CHFunction func);
int lua_setdebug (lua_State *L, int debug);


#endif
